function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
import { flip, shift, size, useFloating, FloatingPortal, offset as offsetMiddleware, autoUpdate, limitShift } from "@floating-ui/react";
import React, { forwardRef } from "react";
import { safeUseId } from "../../../utils";
// TODO: #2003
var LIST_PADDING = 2;
var FloatingPopover = /*#__PURE__*/ forwardRef(function(param, ref) {
    var target = param.target, children = param.children, opened = param.opened, onToggle = param.onToggle, placement = param.placement, portal = param.portal, listWidth = param.listWidth, zIndex = param.zIndex, isInner = param.isInner, offset = param.offset, tmp = param.shift, outsideShift = tmp === void 0 ? false : tmp, tmp1 = param.flip, outsideFlip = tmp1 === void 0 ? false : tmp1;
    var _useFloating = useFloating({
        whileElementsMounted: autoUpdate,
        placement: placement,
        open: opened,
        middleware: [
            offsetMiddleware({
                mainAxis: isInner ? LIST_PADDING * 2 : (offset === null || offset === void 0 ? void 0 : offset[1]) || 0,
                alignmentAxis: isInner ? -LIST_PADDING : (offset === null || offset === void 0 ? void 0 : offset[0]) || 0
            }),
            outsideShift && shift({
                limiter: limitShift()
            }),
            outsideFlip && flip(),
            size({
                apply: function apply(param) {
                    var rects = param.rects, elements = param.elements;
                    Object.assign(elements.floating.style, {
                        width: listWidth || "".concat(isInner ? rects.reference.width + LIST_PADDING * 2 : rects.reference.width, "px")
                    });
                }
            })
        ]
    }), refs = _useFloating.refs, floatingStyles = _useFloating.floatingStyles;
    var wrappedId = safeUseId();
    var handleClick = function handleClick() {
        if (onToggle) {
            onToggle(!opened);
        }
    };
    // Проверка на target. Это может быть как ReactNode, так и функция, в которую пробрасывается ref.
    // Это нужно для более тонкой настройки reference-элемента, вокруг которого и будет позиционироваться выпадашка.
    // Пример: когда в Textfield под инпутом находится helperText (или еще что-либо),
    // но выпадающий список должен позиционироваться непосредственно возле самого инпута.
    var isTargetAsFunction = typeof target === 'function';
    return /*#__PURE__*/ React.createElement("div", {
        ref: ref,
        id: wrappedId,
        style: {
            position: 'relative'
        }
    }, /*#__PURE__*/ React.createElement("div", {
        ref: isTargetAsFunction ? undefined : refs.setReference,
        onClick: handleClick
    }, typeof target === 'function' ? target(refs.setReference) : target), opened && // root - принимает ref контейнера портала.
    // id - если есть портал - не используется, если портала нет - подставляется 'wrappedId'.
    /*#__PURE__*/ React.createElement(FloatingPortal, getFloatingPortalProps(portal, wrappedId), /*#__PURE__*/ React.createElement("div", {
        ref: refs.setFloating,
        style: _object_spread_props(_object_spread({}, floatingStyles), {
            zIndex: zIndex || 1000
        })
    }, children)));
});
// root - принимает ref контейнера портала.
// id - если есть портал - не используется, если портала нет - подставляется 'wrappedId'.
var getFloatingPortalProps = function getFloatingPortalProps(portal, wrappedId) {
    if (!portal) {
        return {
            id: wrappedId
        };
    }
    if (typeof portal === 'string') {
        return {
            id: portal
        };
    }
    return {
        root: portal
    };
};
export { FloatingPopover };
